(*******************************************************************************
**
**  TStealth 1.1
**  copyright  Amigreen Software 1998
**
**  Programming by: Janus N. Tndering 1998 [j@nus.person.dk]
**
**  Comments/questions/bugs? Please write me...
**  TStealth DOES NOT work in Windows NT...sorry! I'm working on an update for NT
**
**  Thanks to...
**    Eric Lawrence [deltagrp@juno.com]
**    John Molyneux [jaymol@hotmail.com]
**
**  Released as copyrighted freeware.
**
**  Disclaimer:
**  AMIGREEN SOFTWARE TAKES NO RESPONSIBILITY FOR ANYTHING
**  HARMED OR DAMAGED BY THIS PIECE OF CODE. IF YOU MODIFY
**  IT, THE AUTHOR(S) KEEPS THE RIGHT TO BE SENT A COPY OF
**  THE MODIFIED SOURCE. YOU CAN FREELY MODIFY AND REDISTRIBUTE
**  FOR NON-PROFIT AS LONG AS THE AUTHOR(S) IS MENTIONED.
**  ALL OTHER RIGHTS RESERVED.
**
*******************************************************************************)

unit Stealth;

interface
uses
  WinTypes, WinProcs, Classes, Forms, SysUtils, Controls, Messages;

type
  TStealth = class(TComponent)
  private
    fHideApp: Boolean;
    procedure SetHideApp(Value: Boolean);
  protected
    { Protected declarations }
    procedure HideApplication;
    procedure ShowApplication;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
//    procedure Loaded; override;
  published
    { Published declarations }
    property HideApp: Boolean read fHideApp write SetHideApp default false;
  end;

function RegisterServiceProcess(dwProcessID, dwType: Integer): Integer; stdcall; external 'KERNEL32.DLL';

procedure Register;

implementation

destructor TStealth.Destroy;
begin
  ShowApplication;
  inherited destroy;
end;

constructor TStealth.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
//  fHideform := true;
end;

procedure TStealth.SetHideApp(Value: Boolean);
begin
  fHideApp := Value;
  if Value then
    HideApplication
  else
    ShowApplication;
end;

procedure TStealth.HideApplication;
begin
  if not (csDesigning in ComponentState) then
    RegisterServiceProcess(GetCurrentProcessID, 1);
end;

procedure TStealth.ShowApplication;
begin
  if not (csDesigning in ComponentState) then
    RegisterServiceProcess(GetCurrentProcessID, 0);
end;

procedure Register;
begin
  RegisterComponents('Amigreen Software', [TStealth]);
end;

end.

